#include <stdio.h>
#include <stdlib.h>

	/* Sieve can find primes up to 2 * N + 1 
	   Add 1 for the zero index + rounding */
#define SIEVE_SZ_FOR(G)	(((G) - 1) / 2 + 1) 
#define SIEVE_SIZE		 (SIEVE_SZ_FOR(1000))

int main(int argc, char *argv[])
{
	if (argc != 2) {
		fprintf(stderr, "Usage: %s N\n", argv[0]);
		return 1;
	}
	
	int G = atoi(argv[1]);
	int N = SIEVE_SZ_FOR(G);
	int sieve[SIEVE_SIZE];
	int i, j;

	/* Initialize. Alternative: memset / static declaration */
	for (i = 0; i < SIEVE_SIZE; i++)
		sieve[i] = 1;

	/* maximaler Wert für i = j  =>  i + i + 2*i+i <= N	 */
	for (i = 1; (i + 1) * i * 2 <= N; i++) {
		for (j = i; i + j + 2*i*j <= N; j++)
			sieve[i + j + 2*i*j] = 0;
	}

	if (G > 2) {
		printf("2\n");
	}

	for (i = 1; 2 * i + 1 < G; i++)
		if (sieve[i])
			printf("%d\n", 2 * i + 1);
	return 0;
}
